﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SqlServer.Types;

// Adapted from Kent Tegles' blog entry at
// http://sqlblog.com/blogs/kent_tegels/archive/2008/08/15/8404.aspx  

namespace Builder_Create_MultiPolygon
{
    public class Class1
    { 
        public static SqlGeometry CreateMultipolygon()
        {
            // Create a new Geometry Builder to work with
            SqlGeometryBuilder gb = new SqlGeometryBuilder();
            // Set the Spatial Reference ID to 1
            gb.SetSrid(1);
            // Start the collection
            gb.BeginGeometry(OpenGisGeometryType.MultiPolygon);
            // Start the first element in this collection
            gb.BeginGeometry(OpenGisGeometryType.Polygon);
            // Define the first element (figure)
            gb.BeginFigure(-77.054700, 38.872957);
            gb.AddLine(-77.057962, 38.872620);
            gb.AddLine(-77.058547, 38.870079);
            gb.AddLine(-77.055592, 38.868840);
            gb.AddLine(-77.053217, 38.870656);
            gb.AddLine(-77.054700, 38.872957);
            // End the first element (figure)
            gb.EndFigure();
            // Define the second figure
            gb.BeginFigure(-77.056972, 38.870639);
            gb.AddLine(-77.055851, 38.870219);
            gb.AddLine(-77.054875, 38.870864);
            gb.AddLine(-77.055452, 38.871804);
            gb.AddLine(-77.056784, 38.871655);
            gb.AddLine(-77.056972, 38.870639);
            gb.EndFigure();
            // End the first polygon
            gb.EndGeometry();
            // Define the second polygon
            gb.BeginGeometry(OpenGisGeometryType.Polygon);
            gb.BeginFigure(-77.056408, 38.875290);
            gb.AddLine(-77.056947, 38.875224);
            gb.AddLine(-77.057466, 38.873598);
            gb.AddLine(-77.057273, 38.872737);
            gb.AddLine(-77.055335, 38.873020);
            gb.AddLine(-77.055499, 38.874058);
            gb.AddLine(-77.056408, 38.875290);
            gb.EndFigure();
            gb.EndGeometry();
            // End (close) the collection
            gb.EndGeometry();
            // Return that as a SqlGeometry instance
            return gb.ConstructedGeometry;
        }

    }
}
