﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using Microsoft.SqlServer.Types;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction]
    public static SqlGeography GeographyFromAnyWKT(SqlChars s, SqlInt32 srid)
    {
        SqlGeography geog = null;

        if (s.IsNull || srid.IsNull)
            return SqlGeography.Null;

        try
        {
            geog = SqlGeography.STGeomFromText(s, srid.Value);
        }
        catch (Exception ex)
        {
            if (ex.Message.Contains("24205"))  // its an invalid ring orientation geography
            {
                SqlGeometry geom = SqlGeometry.STGeomFromText(s, srid.Value);
                geom = geom.MakeValid().STUnion(geom.STStartPoint());
                geog = SqlGeography.STGeomFromText(geom.STAsText(), srid.Value);
            }
            else
            {
                throw ex;
            }
        }

        return geog;
    }
};

